module DistributedCache
  class Config < Struct.new(:cache_dir,
                            :bundle_dir,
                            :file_servers,
                            :file_server_port,
                            :remote_bundle_dir,
                            :file_server_user,
                            :file_server_bundle_dir
                            )

    def initialize
      self.file_server_port = 80
      self.remote_bundle_dir = 'cache/bundles'
      self.cache_dir = "#{Rails.root}/cache" if defined?(Rails)
      self.bundle_dir = "#{Rails.root}/bundles" if defined?(Rails)
    end

    def next_file_server
      @first_file_server_idx ||= rand(self.file_servers.size)
      self.file_servers[@first_file_server_idx].tap do
        @first_file_server_idx = (@first_file_server_idx + 1) % self.file_servers.size
      end
    end

    def file_server_with_port
      if self.file_server_port == 80
        next_file_server
      else
        "#{next_file_server}:#{self.file_server_port}"
      end
    end
  end
end
